<?php

/*
=====================================================
 Custom Comment Fields
-----------------------------------------------------
 http://www.intoeetive.com/
-----------------------------------------------------
 Copyright (c) 2013 Yuri Salimovskiy
=====================================================
 This software is intended for usage with
 ExpressionEngine CMS, version 2.0 or higher
=====================================================
 File: ext.custom_comment_fields.php
-----------------------------------------------------
 Purpose: Everything you ever wanted from comments
=====================================================
*/

if ( ! defined('BASEPATH'))
{
    exit('Invalid file request');
}

require_once PATH_THIRD.'custom_comment_fields/config.php';

class Custom_comment_fields_mcp {

    var $version = CUSTOM_COMMENT_FIELDS_ADDON_VERSION;
    
    var $settings = array();
 
    var $perpage = 50;
    
    function __construct() { 
        // Make a local reference to the ExpressionEngine super object 
        $this->EE =& get_instance();  
        
        $this->EE->lang->loadfile('admin_content');  
        $this->EE->lang->loadfile('comment');  
        $this->EE->lang->loadfile('custom_comment_fields'); 
		
    } 
    
    

    function index()
    {
    	//$this->EE->functions->redirect(BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=comment');
    	return $this->comment_fields();
    }

    
    function comment_fields()
    {
        if ( ! $this->EE->cp->allowed_group(
			'can_access_admin',
			'can_admin_channels',
			'can_access_content_prefs'
		))
		{
			show_error(lang('unauthorized_access'));
		}
		
		$this->EE->load->helper('form');
    	$this->EE->load->library('table');  

    	$vars = array();
        
        $query = $this->EE->db->from('comment_fields')->where('site_id', $this->EE->config->item('site_id'))->get();

        $vars['total_results'] = $query->num_rows();

        $vars['table_headings'] = array(
                        lang('id'),
                        lang('field_label'),
                        lang('field_name'),
                        lang('field_type'),
                        lang('edit'),
                        lang('delete')
                    );      
					
		   
		$i = 0;
		
		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');
		$fts = $this->EE->api_channel_fields->fetch_installed_fieldtypes();
		
        foreach ($query->result() as $obj)
        {
           $vars['data'][$i]['id'] = $obj->field_id;
           $vars['data'][$i]['label'] = $obj->field_label;
           $vars['data'][$i]['name'] = $obj->field_name;
           $vars['data'][$i]['type'] = $fts[$obj->field_type]['name']; 
           $vars['data'][$i]['edit'] = "<a href=\"".BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=edit_comment_field'.AMP.'field_id='.$obj->field_id."\" title=\"".$this->EE->lang->line('edit')."\">".$this->EE->lang->line('edit')."</a>";
           $vars['data'][$i]['delete'] = "<a href=\"".BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=delete_comment_field'.AMP.'field_id='.$obj->field_id."\" title=\"".$this->EE->lang->line('delete')."\">".$this->EE->lang->line('delete')."</a>";
           $i++;
 			
        }
        
        if (version_compare(APP_VER, '2.6.0', '>='))
        {
        	$this->EE->view->cp_page_title = lang('comment_fields');
        }
        else
        {
        	$this->EE->cp->set_variable('cp_page_title', lang('comment_fields'));
        }

/*
		if ($this->EE->cp->allowed_group('can_moderate_comments') &&  
			$this->EE->cp->allowed_group('can_edit_all_comments') && 
			$this->EE->cp->allowed_group('can_delete_all_comments'))
		{
			$this->EE->cp->set_right_nav(
				array(
					'comment_fields'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=comment_fields',
					'settings'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=comment'.AMP.'method=settings',
					'comments'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=comment')
				);	
		}*/
        
    	return $this->EE->load->view('comment_fields', $vars, TRUE);
	
    }
    
    
    function edit_comment_field()
    {
    	if ( ! $this->EE->cp->allowed_group(
			'can_access_admin',
			'can_admin_channels',
			'can_access_content_prefs'
		))
		{
			show_error(lang('unauthorized_access'));
		}
		
		$this->EE->load->helper('form');
    	$this->EE->load->library('table');
		
		$field_id = (int)$this->EE->input->get('field_id');
		
		$vars = $this->_field_edit_vars($field_id);
		
		foreach ($vars['field_type_options'] as $ft_option=>$ft_name)
		{
			if (!in_array($ft_option, array('text', 'textarea', 'safecracker_file', 'file')))
			{
				unset($vars['field_type_options'][$ft_option]);
			}
		}
		//unset($vars['field_type_options']['rel']);
		
		if ($vars === FALSE)
		{
			show_error(lang('unauthorized_access'));
		}
		
    	$current_data = array(
			'field_id'		=> '',
			'field_type'	=> 'text',
			'field_name'	=> '',
			'field_label'	=> '',
			'field_list_items'=>'',
			'field_settings'=>''
		);

    	if ($field_id!=0)
    	{
    		$q = $this->EE->db->from('comment_fields')->where('field_id', $field_id)->get();
    		$current_data['field_id'] 		= $q->row('field_id');
    		$current_data['field_type'] 	= $q->row('field_type');
    		$current_data['field_name'] 	= $q->row('field_name');
    		$current_data['field_label']	= $q->row('field_label');
    		$current_data['field_list_items']= $q->row('field_list_items');
    		$current_data['field_settings'] = $q->row('field_settings');
    	}
		
		
		$vars['data'] = array(	
                'field_type'	=> form_hidden('site_id', $this->EE->config->item('site_id')).form_hidden('field_id', $current_data['field_id']).form_dropdown('field_type', $vars['field_type_options'], $current_data['field_type'], 'id="field_type"'),
                'field_name'	=> form_input('field_name', $current_data['field_name'], 'id="field_name" style="width: 95%"'),
                'field_label'	=> form_input('field_label', $current_data['field_label'], 'id="field_label" style="width: 95%"')
        		);
		
		if ($field_id==0) 
		{
			$this->EE->cp->add_js_script('plugin', 'ee_url_title');

			$this->EE->javascript->output('
				$("#field_label").bind("keyup keydown", function() {
					$(this).ee_url_title("#field_name");
				});
			');
		}
		
		$ft_selector = "#ft_".implode(", #ft_", array_keys($vars['field_type_options']));

		$this->EE->javascript->output('
			var ft_divs = $("'.$ft_selector.'"),
				ft_dropdown = $("#field_type");
		
			ft_dropdown.change(function() {
				ft_divs.hide();
				$("#ft_"+this.value)
					.show()
					.trigger("activate")
					.find("table").trigger("applyWidgets");

			});
			
			ft_dropdown.trigger("change");
		');

		$this->EE->javascript->compile();
		
		if (version_compare(APP_VER, '2.6.0', '>='))
        {
        	$this->EE->view->cp_page_title = lang('comment_fields');
        }
        else
        {
        	$this->EE->cp->set_variable('cp_page_title', lang('comment_fields'));
        }
/*
		if ($this->EE->cp->allowed_group('can_moderate_comments') &&  
			$this->EE->cp->allowed_group('can_edit_all_comments') && 
			$this->EE->cp->allowed_group('can_delete_all_comments'))
		{
			$this->EE->cp->set_right_nav(
				array(
					'comment_fields'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=comment_fields',
					'settings'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=comment'.AMP.'method=settings',
					'comments'	=> BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=comment')
				);	
		}
        */
    	return $this->EE->load->view('edit_comment_field', $vars, TRUE);
    }
    
    
    
    
    
    
    
    
    function save_comment_field()
    {
		if ( ! $this->EE->cp->allowed_group(
			'can_access_admin',
			'can_admin_channels',
			'can_access_content_prefs'
		))
		{
			show_error(lang('unauthorized_access'));
		}

		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');

		// If the $field_id variable has data we are editing an
		// existing group, otherwise we are creating a new one

		$edit = ( ! isset($_POST['field_id']) OR $_POST['field_id'] == '') ? FALSE : TRUE;

		// We need this as a variable as we'll unset the array index

		$group_id = $this->EE->input->post('group_id');

		//perform the field update
		$this->_update_field($_POST);

		// Are there errors to display?

		if (!empty($this->errors))
		{
			$str = '';

			foreach ($this->errors as $msg)
			{
				$str .= $msg.BR;
			}

			show_error($str);
		}

		$cp_message = ($edit) ? lang('custom_field_edited') : lang('custom_field_created');

		$strlen = strlen($this->EE->input->post('field_name'));

		if ($strlen > 32)
		{
			$this->EE->session->set_flashdata('message_failure', lang('field_name_too_lrg'));
		}
		else
		{
			$this->EE->session->set_flashdata('message_success', $cp_message);
		}

		$this->EE->functions->redirect(BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=comment_fields');

	}
    
    
    
    
    
    
    
    function delete_comment_field()
    {
    	
        if (version_compare(APP_VER, '2.6.0', '>='))
        {
        	$this->EE->view->cp_page_title = lang('delete_comment_field');
        }
        else
        {
        	$this->EE->cp->set_variable('cp_page_title', lang('delete_comment_field'));
        }
		
		$vars = array(
			'form_action'	=> 'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=delete_comment_field_final',
			'form_extra'	=> '',
			'message'		=> lang('delete_comment_field_confirmation'),
			'items'			=> array(),
			'form_hidden'	=> array(
				'field_id'		=> $this->EE->input->get('field_id')
			)
		);
		
		$this->EE->load->add_package_path(APPPATH);
        $this->EE->load->helper('form');
        $this->EE->load->helper('view_helper');
        $out = $this->EE->load->view('admin/preference_delete_confirm', $vars, true);
        $this->EE->load->remove_package_path(APPPATH);

		return $out;
    }
    
    
    
    function delete_comment_field_final()
    {
    	$field_id = $this->EE->input->get_post('field_id');
		
		if ($field_id == '' OR ! is_numeric($field_id))
		{
			show_error(lang('not_authorized'));
		}

		$this->EE->db->where('field_id', $field_id);
		$this->EE->db->from('comment_fields');
		$this->EE->db->delete();
		
		$this->EE->load->dbforge(); 
		$this->EE->dbforge->drop_column('comment_data', 'field_id_'.$field_id);

		$this->EE->session->set_flashdata('message_success', lang('field_deleted'));
		$this->EE->functions->redirect(BASE.AMP.'C=addons_modules'.AMP.'M=show_module_cp'.AMP.'module=custom_comment_fields'.AMP.'method=comment_fields');
    }
    
    
    
    
    
    function _field_edit_vars($field_id=FALSE)
    {
		$this->errors = array();
		
		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');
		
		$this->EE->load->library('table');

		$this->EE->load->model('field_model');
		
		$vars = array(
			'field_id' => $field_id,
		);
		
		$this->EE->db->select('*');
		$this->EE->db->from('comment_fields');
		$this->EE->db->where('site_id', $this->EE->config->item('site_id'));
		$this->EE->db->where('field_id', $vars['field_id']);
		
		$field_query = $this->EE->db->get();
		
		if ($field_id == '')
		{
			$type = 'new';

			foreach ($field_query->list_fields() as $f)
			{
				if ( ! isset($vars[$f]))
				{
					$vars[$f] = '';
				}
			}

			$vars['field_order'] = $this->EE->db->count_all('comment_fields') + 1;

		}
		else
		{
			$type = 'edit';
			
			// No valid edit id?  No access
			if ($field_query->num_rows() == 0)
			{
				show_error(lang('unauthorized_access'));
				
				return FALSE;
			}

			foreach ($field_query->row_array() as $key => $val)
			{
				if ($key == 'field_settings' && $val)
				{
					$ft_settings = unserialize(base64_decode($val));
					$vars = array_merge($vars, $ft_settings);
				}
				else
				{
					$vars[$key] = $val;
				}
			}
			
			$vars['update_formatting']	= FALSE;
		}
		
		extract($vars);
		
		$vars['submit_lang_key']	= ($type == 'new') ? 'submit' : 'update';


		$vars['field_pre_populate_id_options'] = array();

		$vars['field_pre_populate_id_select'] = '';

		// build list of formatting options
		if ($type == 'new')
		{
			$vars['edit_format_link'] = '';
			
			$this->EE->load->model('addons_model');
			
			$vars['field_fmt_options'] = $this->EE->addons_model->get_plugin_formatting(TRUE);
		}
		else
		{
			$confirm = "onclick=\"if( !confirm('".lang('list_edit_warning')."')) return false;\"";
			$vars['edit_format_link'] = '<strong><a '.$confirm.' href="'.BASE.AMP.'C=admin_content'.AMP.'M=edit_formatting_options'.AMP.'id='.$field_id.'" title="'.lang('edit_list').'">'.lang('edit_list').'</a></strong>';

			$this->EE->db->select('field_fmt');
			$this->EE->db->where('field_id', $field_id);
			$this->EE->db->order_by('field_fmt');
			$query = $this->EE->db->get('field_formatting');
            
            $vars['field_fmt_options'] = array();

			if ($query->num_rows() > 0)
			{
				foreach ($query->result_array() as $row)
				{
					$name = ucwords(str_replace('_', ' ', $row['field_fmt']));
				
					if ($name == 'Br')
					{
						$name = lang('auto_br');
					}
					elseif ($name == 'Xhtml')
					{
						$name = lang('xhtml');
					}
					$vars['field_fmt_options'][$row['field_fmt']] = $name;
				}
			}
		}

		$vars['field_fmt'] = (isset($field_fmt) && $field_fmt != '') ? $field_fmt : 'none';

		// Prep our own fields
		
		$fts = $this->EE->api_channel_fields->fetch_installed_fieldtypes();
		
		$default_values = array(
			'field_type'					=> isset($fts['text']) ? 'text' : key($fts),
			'field_show_fmt'				=> 'n',
			'field_required'				=> 'n',
			'field_search'					=> 'n',
			'field_is_hidden'				=> 'n',
			'field_pre_populate'			=> 'n',
			'field_show_spellcheck'			=> 'n',
			'field_show_smileys'			=> 'n',
			'field_show_glossary'			=> 'n',
			'field_show_formatting_btns'	=> 'n',
			'field_show_writemode'			=> 'n',
			'field_show_file_selector'		=> 'n',
			'field_text_direction'			=> 'ltr'
		);

		foreach($default_values as $key => $val)
		{
			$vars[$key] = ( ! isset($vars[$key]) OR $vars[$key] == '') ? $val : $vars[$key];
		}
		
		foreach(array('field_pre_populate', 'field_required', 'field_search', 'field_show_fmt') as $key)
		{
			$current = ($vars[$key] == 'y') ? 'y' : 'n';
			$other = ($current == 'y') ? 'n' : 'y';
			
			$vars[$key.'_'.$current] = TRUE;
			$vars[$key.'_'.$other] = FALSE;
		}
		
		// Text Direction
		$current = $vars['field_text_direction'];
		$other = ($current == 'rtl') ? 'ltr' : 'rtl';
		
		$vars['field_text_direction_'.$current] = TRUE;
		$vars['field_text_direction_'.$other] = FALSE;
		
		// Grab Field Type Settings
		
		$vars['field_type_table']	= array();
		$vars['field_type_options']	= array();

		$created = FALSE;

		foreach($fts as $key => $attr)
		{
			// Global settings
			$settings = unserialize(base64_decode($fts[$key]['settings']));
			
			$settings['field_type'] = $key;
			
			$this->EE->table->clear();
			
			$this->EE->api_channel_fields->set_settings($key, $settings);
			$this->EE->api_channel_fields->setup_handler($key);
			
			$str = $this->EE->api_channel_fields->apply('display_settings', array($vars));

			$vars['field_type_tables'][$key]	= $str;
			$vars['field_type_options'][$key]	= $attr['name'];
			
			if (count($this->EE->table->rows))
			{
				$vars['field_type_tables'][$key] = $this->EE->table->rows;
			}
		}

		asort($vars['field_type_options']);	// sort by title

		$vars['form_hidden'] = array(
			'field_id'		=> $field_id,
			'site_id'		=> $this->EE->config->item('site_id')
		);

		$vars['ft_selector'] = "#ft_".implode(", #ft_", array_keys($fts));
		
		return $vars;
	}
	
	
	
	function _update_field(array $field_data)
	{
		$this->errors = array();
		
		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');
		
		$this->EE->load->helper('array');

		// If the $field_id variable has data we are editing an
		// existing group, otherwise we are creating a new one

		$edit = ( ! isset($field_data['field_id']) OR $field_data['field_id'] == '') ? FALSE : TRUE;

		// Check for required fields

		$error = array();
		$this->EE->load->model('field_model');

		// little check in case they switched sites in MSM after leaving a window open.
		// otherwise the landing page will be extremely confusing
		if ( ! isset($field_data['site_id']) OR $field_data['site_id'] != $this->EE->config->item('site_id'))
		{
			show_error(lang('site_id_mismatch'));
		}

		// Was a field name supplied?
		if ($field_data['field_name'] == '')
		{
			show_error(lang('no_field_name'));
		}
		// Is the field one of the reserved words?
		else if (in_array($field_data['field_name'], $this->EE->cp->invalid_custom_field_names()))
		{
			show_error(lang('reserved_word'));
		}

		// Was a field label supplied?
		if ($field_data['field_label'] == '')
		{
			show_error(lang('no_field_label'));
		}

		// Does field name contain invalid characters?
		if (preg_match('/[^a-z0-9\_\-]/i', $field_data['field_name']))
		{
			$this->errors[] = lang('invalid_characters').': '.$field_data['field_name'];
		}

		// Is the field name taken?
		$this->EE->db->where(array(
			'site_id' => $this->EE->config->item('site_id'),
			'field_name' => element('field_name', $field_data),
		));

		if ($edit == TRUE)
		{
			$this->EE->db->where('field_id !=', element('field_id', $field_data));
		}

		if ($this->EE->db->count_all_results('channel_fields') > 0)
		{
			show_error(lang('duplicate_field_name'));
		}

		$field_type = $field_data['field_type'];

		// If they are setting a file type, ensure there is at least one upload directory available
		if ($field_type == 'file')
		{
			$this->EE->load->model('file_upload_preferences_model');
			$upload_dir_prefs = $this->EE->file_upload_preferences_model->get_file_upload_preferences();
			
			// count upload dirs
			if (count($upload_dir_prefs) === 0)
			{
				$this->EE->lang->loadfile('filemanager');
				show_error(lang('please_add_upload'));
			}
		}

		// Are there errors to display?

		if (count($this->errors) > 0)
		{
			return FALSE;
		}
		
		$native = array(
			'field_id', 'site_id',
			'field_name', 'field_label',
			'field_type', 'field_list_items',
			'field_related_id', 'field_related_orderby', 'field_related_sort', 'field_related_max',
			'field_ta_rows', 'field_maxl', 'field_required',
			'field_order',
			'field_text_direction', 'field_show_fmt', 'field_fmt'
		);
		
		
		
		$_posted = array();
		$_field_posted = preg_grep('/^'.$field_type.'_.*/', array_keys($field_data));
		$_keys = array_merge($native,  $_field_posted);

		foreach($_keys as $key)
		{
			if (isset($field_data[$key]))
			{
				$_posted[$key] = $field_data[$key];
			}
		}

		// Get the field type settings
		$this->EE->api_channel_fields->fetch_all_fieldtypes();
		$this->EE->api_channel_fields->setup_handler($field_type);
		$ft_settings = $this->EE->api_channel_fields->apply('save_settings', array($_posted));
		
		// Default display options
		foreach(array('smileys', 'glossary', 'spellcheck', 'formatting_btns', 'file_selector', 'writemode') as $key)
		{
			$tmp = $this->_get_ft_data($field_type, 'field_show_'.$key, $field_data);
			$ft_settings['field_show_'.$key] = $tmp ? $tmp : 'n';
		}
		
		// Now that they've had a chance to mess with the POST array,
		// grab post values for the native fields (and check namespaced fields)
		foreach($native as $key)
		{
			$native_settings[$key] = $this->_get_ft_data($field_type, $key, $field_data);
		}
		
		// Set some defaults
		$native_settings['field_related_id']		= ($tmp = $this->_get_ft_data($field_type, 'field_related_channel_id', $field_data)) ? $tmp : '0';
		$native_settings['field_list_items']		= ($tmp = $this->_get_ft_data($field_type, 'field_list_items', $field_data)) ? $tmp : '';
				
		$native_settings['field_text_direction']	= ($native_settings['field_text_direction'] !== FALSE) ? $native_settings['field_text_direction'] : 'ltr';
		$native_settings['field_show_fmt']			= ($native_settings['field_show_fmt'] !== FALSE) ? $native_settings['field_show_fmt'] : 'n';
		$native_settings['field_fmt']				= ($native_settings['field_fmt'] !== FALSE) ? $native_settings['field_fmt'] : 'xhtml';

		
		// If they returned a native field value as part of their settings instead of changing the post array,
		// we'll merge those changes into our native settings
		
		foreach($ft_settings as $key => $val)
		{
			if (in_array($key, $native))
			{
				unset($ft_settings[$key]);
				$native_settings[$key] = $val;
			}
		}

		if (!isset($field_data['field_order']) OR $field_data['field_order'] == 0 OR $field_data['field_order'] == '')
		{
			$query = $this->EE->db->select('MAX(field_order) as max')
					      ->where('site_id', $this->EE->config->item('site_id'))
					      ->get('comment_fields');
				
			$native_settings['field_order'] = (int) $query->row('max') + 1;
		}
		
		$native_settings['field_settings'] = base64_encode(serialize($ft_settings));
		
		// Construct the query based on whether we are updating or inserting
		if ($edit === TRUE)
		{
			if ( ! is_numeric($native_settings['field_id']))
			{
				return FALSE;
			}

			// Update the formatting for all existing entries
			/*if ($this->_get_ft_data($field_type, 'update_formatting', $field_data) == 'y')
			{
				$this->EE->db->update(
					'comment_data',
					array('field_ft_'.$native_settings['field_id'] => $native_settings['field_fmt'])
				);
			}*/

				
			// Send it over to drop old fields, add new ones, and modify as needed
			$this->edit_datatype(
				$native_settings['field_id'],
				$field_type,
				$native_settings
			);

			$this->EE->db->where('field_id', $native_settings['field_id']);
			$this->EE->db->update('comment_fields', $native_settings);

			// Update saved layouts if necessary
			//$collapse = ($native_settings['field_is_hidden'] == 'y') ? TRUE : FALSE;
			$buttons = ($ft_settings['field_show_formatting_btns'] == 'y') ? TRUE : FALSE;

		}
		else
		{
			if ( ! $native_settings['field_ta_rows'])
			{
				$native_settings['field_ta_rows'] = 0;
			}

			// as its new, there will be no field id, unset it to prevent an empty string from attempting to pass
			unset($native_settings['field_id']);

			$this->EE->db->insert('comment_fields', $native_settings);

			$insert_id = $this->EE->db->insert_id();
			$native_settings['field_id'] = $insert_id;

			$this->add_datatype(
				$insert_id, 
				$native_settings
			);
/*
			$this->EE->db->update('comment_data', array('field_ft_'.$insert_id => $native_settings['field_fmt'])); 

			$field_formatting = array('none', 'br', 'xhtml');
			
			//if the selected field formatting is not one of the native formats, make sure it gets added to exp_field_formatting for this field
			if ( ! in_array($native_settings['field_fmt'], $field_formatting))
			{
				$field_formatting[] = $native_settings['field_fmt'];
			}

			foreach ($field_formatting as $val)
			{
				$f_data = array('field_id' => $insert_id, 'field_fmt' => $val);
				$this->EE->db->insert('field_formatting', $f_data); 
			}
			
			$collapse = ($native_settings['field_is_hidden'] == 'y') ? TRUE : FALSE;*/
			$buttons = ($ft_settings['field_show_formatting_btns'] == 'y') ? TRUE : FALSE;
			
			$field_info['publish'][$insert_id] = array(
								'visible'		=> 'true',
								'htmlbuttons'	=> $buttons,
								'width'			=> '100%'
			);
			
		}
		
		$_final_settings = array_merge($native_settings, $ft_settings);
		unset($_final_settings['field_settings']);
		
		$this->EE->api_channel_fields->set_settings($native_settings['field_id'], $_final_settings);
		$this->EE->api_channel_fields->setup_handler($native_settings['field_id']);
		$this->EE->api_channel_fields->apply('post_save_settings', array($_posted));

		$this->EE->functions->clear_caching('all', '', TRUE);
		
		return $native_settings['field_id'];
	}
	
	
	
	function edit_datatype($field_id, $field_type, $data)
	{
		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');
		
		$old_fields = array();
		
		// First we get the data
		$query = $this->EE->db->get_where('comment_fields', array('field_id' => $field_id));
		
		$this->EE->api_channel_fields->setup_handler($query->row('field_type'));
		
		// Field type changed ?
		$type = ($query->row('field_type') == $field_type) ? 'get_data' : 'delete';

		$old_data = $query->row_array();
		
		// merge in a few variables to the data array
		$old_data['field_id'] = $field_id;
		$old_data['ee_action'] = $type;

		$old_fields = $this->EE->api_channel_fields->apply('settings_modify_column', array($old_data));

		// Switch handler back to the new field type
		$this->EE->api_channel_fields->setup_handler($field_type);

		if ( ! isset($old_fields['field_id_'.$field_id]))
		{
			$old_fields['field_id_'.$field_id]['type'] = 'text';
			$old_fields['field_id_'.$field_id]['null'] = TRUE;
		}
		/*
		if ( ! isset($old_fields['field_ft_'.$field_id]))
		{
			$old_fields['field_ft_'.$field_id]['type'] = 'tinytext';
			$old_fields['field_ft_'.$field_id]['null'] = TRUE;
		}
		*/
		// Delete extra fields
		if ($type == 'delete')
		{
			$this->EE->load->dbforge();
			$delete_fields = array_keys($old_fields);
				
			foreach ($delete_fields as $col)
			{
				if ($col == 'field_id_'.$field_id OR $col == 'field_ft_'.$field_id)
				{
					continue;
				}

				$this->EE->dbforge->drop_column('comment_data', $col);
			}
			
		}
		
		$type_change = ($type == 'delete') ? TRUE : FALSE;
		
		$this->set_datatype($field_id, $data, $old_fields, FALSE, $type_change);
	}	
	
	
	
	function set_datatype($field_id, $data, $old_fields = array(), $new = TRUE, $type_change = FALSE)
	{		
		$this->EE->load->library('api');
		$this->EE->api->instantiate('channel_fields');
		
		$this->EE->load->dbforge();
		
		// merge in a few variables to the data array
		$data['field_id'] = $field_id;
		$data['ee_action'] = 'add';
		
		// We have to get the new fields regardless to check whether they were modified
		$fields = $this->EE->api_channel_fields->apply('settings_modify_column', array($data));
		
		if ( ! isset($fields['field_id_'.$field_id]))
		{
			$fields['field_id_'.$field_id]['type'] = 'text';
			$fields['field_id_'.$field_id]['null'] = TRUE;
		}
		/*
		if ( ! isset($fields['field_ft_'.$field_id]))
		{
			$fields['field_ft_'.$field_id]['type'] = 'tinytext';
			$fields['field_ft_'.$field_id]['null'] = TRUE;
		}
		*/
		// Do we need to modify the field_id
		$modify = FALSE;

		if ( ! $new)
		{
			$diff1 = array_diff_assoc($old_fields['field_id_'.$field_id], $fields['field_id_'.$field_id]);
			$diff2 = array_diff_assoc($fields['field_id_'.$field_id], $old_fields['field_id_'.$field_id]);
		
			if ( ! empty($diff1) OR ! empty($diff2))
			{
				$modify = TRUE;
			}
		}

		// Add any new fields
		if ($type_change == TRUE OR $new == TRUE)
		{
			foreach ($fields as $field => $prefs)
			{
				if ( ! $new)
				{
					if ($field == 'field_id_'.$field_id OR $field == 'field_ft_'.$field_id)
					{
						continue;
					}
				}
				
				$this->EE->dbforge->add_column('comment_data', array($field => $prefs));
				
				// Make sure the value is an empty string
				$this->EE->db->update(
					'comment_data',
					array(
						$field => (isset($prefs['default'])) ? $prefs['default'] : ''
					)
				);
			}
		}
		
		// And modify any necessary fields
		if ($modify == TRUE)
		{
			$mod['field_id_'.$field_id] = $fields['field_id_'.$field_id];
			$mod['field_id_'.$field_id]['name'] = 'field_id_'.$field_id;
			
			$this->EE->dbforge->modify_column('comment_data', $mod);
		}
	}
	
	
	
	protected function _get_ft_data($field_type, $key, $field_data)
	{
		if (isset($field_data[$key]))
		{
			return $field_data[$key];
		}
		
		$key = $field_type.'_'.$key;
		
		return (isset($field_data[$key])) ? $field_data[$key] : FALSE;
	}
	
	
	
	
	function add_datatype($field_id, $data)
	{
		$this->set_datatype($field_id, $data, array(), TRUE);
	}
	
	


}
/* END */
?>